package com.zhongzheng.modules.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.pay.domain.PayAisle;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.pay.bo.PayCostAddBo;
import com.zhongzheng.modules.pay.bo.PayCostQueryBo;
import com.zhongzheng.modules.pay.bo.PayCostEditBo;
import com.zhongzheng.modules.pay.domain.PayCost;
import com.zhongzheng.modules.pay.mapper.PayCostMapper;
import com.zhongzheng.modules.pay.vo.PayCostVo;
import com.zhongzheng.modules.pay.service.IPayCostService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 费用类型Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-12
 */
@Service
public class PayCostServiceImpl extends ServiceImpl<PayCostMapper, PayCost> implements IPayCostService {

    @Override
    public PayCostVo queryById(Long costId){
        PayCost db = this.baseMapper.selectById(costId);
        return BeanUtil.toBean(db, PayCostVo.class);
    }

    @Override
    public List<PayCostVo> queryList(PayCostQueryBo bo) {
        LambdaQueryWrapper<PayCost> lqw = Wrappers.lambdaQuery();
        lqw.like(StrUtil.isNotBlank(bo.getCostName()), PayCost::getCostName, bo.getCostName());
        lqw.in(bo.getStatus() != null, PayCost::getStatus, bo.getStatus());
        lqw.orderByDesc(PayCost::getUpdateTime);
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<PayCostVo> entity2Vo(Collection<PayCost> collection) {
        List<PayCostVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, PayCostVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<PayCost> page = (Page<PayCost>)collection;
            Page<PayCostVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(PayCostAddBo bo) {
        PayCost add = BeanUtil.toBean(bo, PayCost.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(PayCostEditBo bo) {
        PayCost update = BeanUtil.toBean(bo, PayCost.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(PayCost entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
